// TrafficLight.h
// Demo control class header file

#pragma once

namespace TrafficLightDemo
{
using namespace System;
using namespace System::Windows::Forms;

[Flags]
public enum class TrafficLightState
{
  Dark = 0x00, Red = 0x01, Yellow = 0x02, Green = 0x04,
  RedYellow = Red | Yellow, GreenYellow = Green | Yellow
};

public ref class TrafficLight : public Panel
{
public:
  TrafficLight();

  void AdvanceCycle();

protected:
  virtual array<TrafficLightState> ^GetCycleArray();

private:
  PictureBox ^CreateLightPbx(String ^strFileName, int nTop);
  void LightPbxClickHandler(Object ^sender, EventArgs ^e);

public:
  property TrafficLightState State
  {
    TrafficLightState get();
    void set(TrafficLightState value);
  }

protected:
  // Entirely trivial property override implemented right here for brevity:

  virtual property Drawing::Size DefaultSize
  {
    Drawing::Size get() override
    {
      return Drawing::Size(47, 119);
    }
  }

private:
  PictureBox ^m_pbxRed;
  PictureBox ^m_pbxYellow;
  PictureBox ^m_pbxGreen;
  TrafficLightState m_state;
  array<TrafficLightState> ^m_atlsCycleArray;
  int m_nCycleIndex;
};

}
